VERSION 5.00
Begin VB.Form Form1 
   AutoRedraw      =   -1  'True
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Form1"
   ClientHeight    =   6615
   ClientLeft      =   2040
   ClientTop       =   2190
   ClientWidth     =   10395
   BeginProperty Font 
      Name            =   "Courier New"
      Size            =   9
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   6615
   ScaleWidth      =   10395
   Begin VB.CommandButton cmdExit 
      Caption         =   "Exit"
      Height          =   615
      Left            =   7560
      TabIndex        =   2
      Top             =   5820
      Width           =   2715
   End
   Begin VB.CommandButton cmdSortState 
      Caption         =   "Sort by Last Name Within State"
      Height          =   615
      Left            =   3840
      TabIndex        =   1
      Top             =   5820
      Width           =   3555
   End
   Begin VB.CommandButton cmdSortLast 
      Caption         =   "Sort by Last Name"
      Height          =   615
      Left            =   120
      TabIndex        =   0
      Top             =   5820
      Width           =   3555
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private mastrCustRec() As String

'------------------------------------------------------------------------
Private Sub cmdSortLast_Click()
'------------------------------------------------------------------------
    DisplayCustInfo "L"
End Sub

'------------------------------------------------------------------------
Private Sub cmdSortState_Click()
'------------------------------------------------------------------------
    DisplayCustInfo "S"
End Sub

'------------------------------------------------------------------------
Private Sub cmdExit_Click()
'------------------------------------------------------------------------
    End
End Sub

'------------------------------------------------------------------------
Private Sub DisplayCustInfo(pstrSortType As String)
'------------------------------------------------------------------------
  
    Dim strCustFileName As String
    Dim strBackSlash    As String
    Dim intCustFileNbr  As Integer
    Dim intX            As Integer
    Dim intArrX         As Integer
    
    Dim strLastName     As String
    Dim strFirstName    As String
    Dim strAddr         As String
    Dim strCity         As String
    Dim strState        As String
    Dim strZip          As String
    Dim strFixedRec     As String
    
    Cls
    
    strBackSlash = IIf(Right$(App.Path, 1) = "\", "", "\")
    strCustFileName = App.Path & strBackSlash & "CustTest.txt"
    intCustFileNbr = FreeFile
    
    Open strCustFileName For Input As #intCustFileNbr

    
    Do Until EOF(intCustFileNbr)
        Input #intCustFileNbr, strLastName, _
                               strFirstName, _
                               strAddr, _
                               strCity, _
                               strState, _
                               strZip
        strFixedRec = ""
        If pstrSortType = "L" Then
            strFixedRec = Left$(strLastName & Space$(20), 20)
        Else
            strFixedRec = Left$(strState & strLastName & Space$(20), 20)
        End If
        strFixedRec = strFixedRec _
                    & Left$(strLastName & Space$(15), 15) _
                    & Left$(strFirstName & Space$(15), 15) _
                    & Left$(strCity & Space$(25), 25) _
                    & strState
        intArrX = intArrX + 1
        ReDim Preserve mastrCustRec(1 To intArrX)
        mastrCustRec(intArrX) = strFixedRec
    Loop

    Close #intCustFileNbr
    
    SortRecordArray mastrCustRec, 1, 20
    
    Print "LAST NAME      FIRST NAME     CITY                     STATE"
    Print "---------      ----------     ----                     -----"
    For intX = 1 To UBound(mastrCustRec)
        Print Mid$(mastrCustRec(intX), 21)
    Next


End Sub

'------------------------------------------------------------------------
Private Sub SortRecordArray(pastrRecArray() As String, _
                            plngSortKeyStart As Long, _
                            plngSortKeyLength As Long)
'------------------------------------------------------------------------

    ' This sub uses the Bubble Sort algorithm to sort an array of records.

    Dim lngX        As Long
    Dim lngY        As Long
    Dim strTempRec  As String
    
    For lngX = LBound(pastrRecArray) To (UBound(pastrRecArray) - 1)
    
        For lngY = LBound(pastrRecArray) To (UBound(pastrRecArray) - 1)
        
            If Mid$(pastrRecArray(lngY), plngSortKeyStart, plngSortKeyLength) _
             > Mid$(pastrRecArray(lngY + 1), plngSortKeyStart, plngSortKeyLength) _
            Then
                strTempRec = pastrRecArray(lngY)
                pastrRecArray(lngY) = pastrRecArray(lngY + 1)
                pastrRecArray(lngY + 1) = strTempRec
            End If
        
        Next
    
    Next

End Sub
